#include <fstream>
#include "image.h"


static int toByte(Scalar s) {
    return int( round(s*255) );
}

// A simple image format that is super-easy to export
// Info on: https://en.wikipedia.org/wiki/Netpbm
// See produced images with most image viewers.
void Image::exportPPM(std::string filename) const {
    std::ofstream f;
    f.open(filename);
    f << "P3\n" << resX << " " << resY << "\n" << 255 << "\n"; // header

    /* Scan the array of pixels: the C style */
    /*
    for (int i=0; i<data.size() ; i++) {
        const Color& c = data[i];
        // ... do something with c
    }
    */

    /* Scan the array of pixels: the C++ way */
    for (const Color& c: data ) {
        f << toByte(c.x) << " " << toByte(c.y)  << " " << toByte(c.z) << "\n";
    }

    f.close();
}
